package jp.hishidama.swing.layout;

import java.awt.Component;
import java.awt.Container;
import java.util.Iterator;

import javax.swing.GroupLayout;
import javax.swing.JLabel;
import javax.swing.GroupLayout.Group;
import javax.swing.GroupLayout.ParallelGroup;
import javax.swing.GroupLayout.SequentialGroup;

/**
 * GroupLayout[eBeB[.
 *
 * <p>
 * R|[lg̓񎟌z{@link javax.swing.GroupLayout GroupLayout}ŔzuB<br>
 * <a target="hishidama" href="http://www.ne.jp/asahi/hishidama/home/tech/soft/java/swing/GroupLayoutUtil.html"
 * >gp</a>
 * </p>
 * <p>
 * NX̓CX^XtB[hɌʂ̒lێ̂ŁAMTZ[tł͂ȂB
 * </p>
 *
 * @author <a target="hishidama" href="http://www.ne.jp/asahi/hishidama/home/tech/soft/java/swing/GroupLayoutUtil.html"
 *         >Ђ</a>
 * @since 2009.11.06
 * @version 2009.11.07
 */
public class GroupLayoutUtil {

	/** z̍ƓR|[lgzu */
	public static final Component SAME_L = new JLabel("Ɠ");
	/** z̏㑤ƓR|[lgzu */
	public static final Component SAME_U = new JLabel("Ɠ");

	/**
	 * MbvwR|[lg.
	 * <p>
	 * R|[lg̍яɃMbvǉׂ̃R|[lgB<br>
	 * <a target="hishidama" href="http://www.ne.jp/asahi/hishidama/home/tech/soft/java/swing/GroupLayoutUtil.html#h_sample_gap"
	 * >gp</a>
	 * </p>
	 *
	 * @author <a target="hishidama" href="http://www.ne.jp/asahi/hishidama/home/tech/soft/java/swing/GroupLayoutUtil.html"
	 *         >Ђ</a>
	 * @since 2009.11.07
	 */
	public static class Gap extends Component {
		private static final long serialVersionUID = -3143356632258067324L;
		protected Component comp;
		protected int colMin, colPref, colMax;
		protected int rowMin, rowPref, rowMax;

		/**
		 * RXgN^[.
		 *
		 * @param comp
		 *            R|[lg
		 * @param colSize
		 *            MbvTCYîƂ̓MbvǉȂj
		 * @param rowSize
		 *            sMbvTCYîƂ̓MbvǉȂj
		 * @see SequentialGroup#addGap(int)
		 */
		public Gap(Component comp, int colSize, int rowSize) {
			this(comp, colSize, colSize, colSize, rowSize, rowSize, rowSize);
		}

		/**
		 * RXgN^[.
		 *
		 * @param comp
		 *            R|[lg
		 * @param colMin
		 *            MbvŏTCY
		 * @param colPref
		 *            MbvTCYîƂ̓MbvǉȂj
		 * @param colMax
		 *            MbvőTCY
		 * @param rowMin
		 *            sMbvŏTCY
		 * @param rowPref
		 *            sMbvTCYîƂ̓MbvǉȂj
		 * @param rowMax
		 *            sMbvőTCY
		 * @see SequentialGroup#addGap(int, int, int)
		 */
		public Gap(Component comp, int colMin, int colPref, int colMax,
				int rowMin, int rowPref, int rowMax) {
			this.comp = comp;
			this.colMin = colMin;
			this.colPref = colPref;
			this.colMax = colMax;
			this.rowMin = rowMin;
			this.rowPref = rowPref;
			this.rowMax = rowMax;
		}

		/**
		 * R|[lg擾.
		 *
		 * @return R|[lg
		 */
		public Component getComponent() {
			return comp;
		}
	}

	protected Component[][] components;
	protected int xsize, ysize;

	protected GroupLayout groupLayout;

	protected CreateColGroup colCreator = new CreateColGroup();
	protected CreateRowGroup rowCreator = new CreateRowGroup();

	/**
	 * RXgN^[.
	 */
	public GroupLayoutUtil() {
	}

	/**
	 * R|[lgzݒ.
	 *
	 * @param components
	 *            R|[lg̓񎟌z
	 */
	public void setComponents(Component[][] components) {
		this.components = components;
		this.ysize = components.length;
		this.xsize = 0;
		for (int i = 0; i < ysize; i++) {
			Component[] line = components[i];
			xsize = Math.max(xsize, line.length);
		}
	}

	/**
	 * R|[lgz擾.
	 *
	 * @return R|[lg̓񎟌z
	 */
	public Component[][] getComponents() {
		return components;
	}

	/**
	 * R|[lgz̉̌擾.
	 *
	 * @return z
	 */
	public int getXSize() {
		return xsize;
	}

	/**
	 * R|[lgz̏č擾.
	 *
	 * @return z
	 */
	public int getYSize() {
		return ysize;
	}

	/**
	 * R|[lg擾.
	 *
	 * @param x
	 *            X
	 * @param y
	 *            Y
	 * @return R|[lgiz͈̔͊Ȍꍇnullj
	 */
	public Component getComponent(int x, int y) {
		if (y < 0 || y >= ysize || x < 0) {
			return null;
		}
		Component[] line = components[y];
		if (x >= line.length) {
			return null;
		}
		return line[x];
	}

	/**
	 * GroupLayoutݒ.
	 *<p>
	 * R|[lgzuGroupLayout𐶐Aw肳ꂽReiɓo^B
	 * </p>
	 *
	 * @param container
	 *            Rei
	 */
	public void setGroupLayoutTo(Container container) {
		groupLayout = createGroupLayout(container);
		initGroupLayout(groupLayout);
		{
			Group cols = colCreator.createGroup(0, xsize);
			groupLayout.setHorizontalGroup(cols);
		}
		{
			Group rows = rowCreator.createGroup(0, ysize);
			groupLayout.setVerticalGroup(rows);
		}
		container.setLayout(groupLayout);
	}

	/**
	 * GroupLayoutCX^X.
	 *
	 * @param container
	 *            Rei
	 * @return GroupLayout
	 * @see #setGroupLayoutTo(Container)
	 */
	protected GroupLayout createGroupLayout(Container container) {
		return new GroupLayout(container);
	}

	/**
	 * GroupLayout.
	 *
	 * @param layout
	 *            GroupLayout
	 */
	protected void initGroupLayout(GroupLayout layout) {
		// 
		// R|[lgm̊Ԋu󂯂ݒ
		// layout.setAutoCreateGaps(true);
		// layout.setAutoCreateContainerGaps(true);
	}

	/**
	 * GroupLayout擾.
	 *<p>
	 * {@link #setGroupLayoutTo(Container)}ĂłłȂƁAnullԂB
	 * </p>
	 *
	 * @return GroupLayout
	 * @see #setGroupLayoutTo(Container)
	 */
	public GroupLayout getGroupLayout() {
		return groupLayout;
	}

	/**
	 * CAEgzu{.
	 */
	protected abstract class CreateGroup {

		/**
		 * CAEgs.
		 *
		 * @param x
		 *            Jnʒu
		 * @param mx
		 *            Iʒu
		 * @return O[v
		 */
		public Group createGroup(int x, int mx) {
			SequentialGroup sg = groupLayout.createSequentialGroup();
			while (x < mx) {
				if (!nextIsSame(x)) {
					// ESAME1Ƃ
					ParallelGroup pg = createGroup1(x);
					if (pg != null) {
						addGap(sg, x);
						sg.addGroup(pg);
					}
					x++;
					continue;
				}

				// ESAME1łƂ
				int sx = lastSame(x + 1, mx);
				if (sx < 0) {
					throw new IllegalStateException();
				}
				Group ng = createGroup(x + 1, sx + 1);

				ParallelGroup pg = createGroup1(x, true); // ESAME
				ParallelGroup pg0 = createGroup1(x, false); // ESAMEȂ
				if (pg0 == null) {
					pg0 = createParallelGroup(); // ̃O[v
				}
				SequentialGroup sg0 = groupLayout.createSequentialGroup();
				sg0.addGroup(pg0);
				addGap(sg0, x + 1);
				sg0.addGroup(ng);
				pg.addGroup(sg0);

				addGap(sg, x);
				sg.addGroup(pg);
				x = sx + 1;
			}
			return sg;
		}

		/**
		 * 񕪂ParallelGroup쐬B
		 *
		 * @param x
		 * @return O[v
		 */
		protected ParallelGroup createGroup1(int x) {
			ParallelGroup pg = null;
			for (int y : getIterable()) {
				Component c = get(x, y);
				if (c == null || c == SAME_U || c == SAME_L) {
					continue;
				}
				if (pg == null) {
					pg = createParallelGroup();
				}
				addComponent(pg, c);
			}
			return pg;
		}

		/**
		 * 񕪂ParallelGroup쐬B
		 *
		 * @param x
		 * @param nextIsSame
		 *            trueFESAMÊ̂IB<br>
		 *            falseFESAMEłȂ̂IB
		 * @return O[v
		 */
		protected ParallelGroup createGroup1(int x, boolean nextIsSame) {
			ParallelGroup pg = null;
			for (int y : getIterable()) {
				Component c = get(x, y);
				if (c == null || c == SAME_U || c == SAME_L) {
					continue;
				}
				Component n = get(x + 1, y);
				if (isSame(n) == nextIsSame) {
					if (pg == null) {
						pg = createParallelGroup();
					}
					addComponent(pg, c);
				}
			}
			return pg;
		}

		/**
		 * uLȃR|[lgŁAESAMEłv݂̂邩ǂ𔻒肷B
		 *
		 * @param x
		 * @return trueFESAMEł݂̂
		 */
		protected boolean nextIsSame(int x) {
			for (int y : getIterable()) {
				Component c = get(x, y);
				if (c == null || c == SAME_U || c == SAME_L) {
					continue;
				}
				Component n = get(x + 1, y);
				if (isSame(n)) {
					return true;
				}
			}
			return false;
		}

		/**
		 * uSAME1łvAđ݂AԉË̗ʒuԂB
		 *
		 * @param x
		 *            Jnʒu
		 * @param mx
		 *            Iʒu
		 * @return ԉËʒu
		 */
		protected int lastSame(int x, int mx) {
			int last = -1;
			for (int i = x; i < mx; i++) {
				if (existSame(i)) {
					last = i;
					continue;
				}
				break;
			}
			return last;
		}

		protected abstract Component get(int x, int y);

		protected abstract boolean existSame(int x);

		protected abstract boolean isSame(Component c);

		protected abstract Iterable<Integer> getIterable();

		protected abstract ParallelGroup createParallelGroup();

		protected void addComponent(Group group, Component c) {
			if (c instanceof Gap) {
				c = ((Gap) c).getComponent();
			}
			group.addComponent(c);
		}

		protected abstract void addGap(SequentialGroup sg, int x);
	}

	/**
	 * ̃CAEgzuNX.
	 */
	protected class CreateColGroup extends CreateGroup {

		@Override
		protected Component get(int x, int y) {
			return getComponent(x, y);
		}

		@Override
		protected boolean existSame(int x) {
			for (int y : getIterable()) {
				Component c = getComponent(x, y);
				if (isSame(c)) {
					return true;
				}
			}
			return false;
		}

		@Override
		protected boolean isSame(Component c) {
			return c == SAME_L;
		}

		@Override
		protected Iterable<Integer> getIterable() {
			return new Iterable<Integer>() {
				@Override
				public Iterator<Integer> iterator() {
					return new Iterator<Integer>() {
						int i = 0;

						@Override
						public boolean hasNext() {
							return i < ysize;
						}

						@Override
						public Integer next() {
							return i++;
						}

						@Override
						public void remove() {
							throw new UnsupportedOperationException();
						}
					};
				}
			};
		}

		@Override
		protected ParallelGroup createParallelGroup() {
			return groupLayout.createParallelGroup();
		}

		@Override
		protected void addGap(SequentialGroup sg, int x) {
			final int PREF_NONE = -1;
			int min = Integer.MAX_VALUE, pref = PREF_NONE, max = Integer.MIN_VALUE;
			for (int y : getIterable()) {
				Component c = getComponent(x, y);
				if (c instanceof Gap) {
					Gap g = (Gap) c;
					if (g.colPref < 0) {
						continue;
					}
					if (pref > PREF_NONE && pref != g.colPref) {
						String msg = String.format(
								"colPrefsv(%d,%d) pref=%d/%d", x, y, pref,
								g.colPref);
						throw new IllegalStateException(msg);
					}
					pref = g.colPref;
					min = Math.min(min, g.colMin);
					max = Math.max(max, g.colMax);
				}
			}
			if (pref > PREF_NONE) {
				sg.addGap(min, pref, max);
			}
		}
	}

	/**
	 * s̃CAEgzuNX.
	 */
	protected class CreateRowGroup extends CreateGroup {

		@Override
		protected Component get(int y, int x) {
			return getComponent(x, y);
		}

		@Override
		protected boolean existSame(int y) {
			for (int x : getIterable()) {
				Component c = getComponent(x, y);
				if (isSame(c)) {
					return true;
				}
			}
			return false;
		}

		@Override
		protected boolean isSame(Component c) {
			return c == SAME_U;
		}

		@Override
		protected Iterable<Integer> getIterable() {
			return new Iterable<Integer>() {
				@Override
				public Iterator<Integer> iterator() {
					return new Iterator<Integer>() {
						int i = 0;

						@Override
						public boolean hasNext() {
							return i < xsize;
						}

						@Override
						public Integer next() {
							return i++;
						}

						@Override
						public void remove() {
							throw new UnsupportedOperationException();
						}
					};
				}
			};
		}

		@Override
		protected ParallelGroup createParallelGroup() {
			return groupLayout
					.createParallelGroup(GroupLayout.Alignment.BASELINE);
		}

		@Override
		protected void addGap(SequentialGroup sg, int y) {
			final int PREF_NONE = -1;
			int min = Integer.MAX_VALUE, pref = PREF_NONE, max = Integer.MIN_VALUE;
			for (int x : getIterable()) {
				Component c = getComponent(x, y);
				if (c instanceof Gap) {
					Gap g = (Gap) c;
					if (g.rowPref < 0) {
						continue;
					}
					if (pref > PREF_NONE && pref != g.rowPref) {
						String msg = String.format(
								"rowPrefsv(%d,%d) pref=%d/%d", x, y, pref,
								g.rowPref);
						throw new IllegalStateException(msg);
					}
					pref = g.rowPref;
					min = Math.min(min, g.rowMin);
					max = Math.max(max, g.rowMax);
				}
			}
			if (pref > PREF_NONE) {
				sg.addGap(min, pref, max);
			}
		}
	}
}
